# Uses of Interface
net.shibboleth.idp.attribute.IdPAttributeValue

Packages that use IdPAttributeValue
Package
Description
net.shibboleth.idp.attribute
`IdPAttribute`s are protocol-agnostic units of information about some thing, usually a user.
net.shibboleth.idp.attribute.filter
This package contains a filtering engine for a collection of `IdPAttribute`s.
net.shibboleth.idp.attribute.filter.context
The contexts to do with attribute filtering.
net.shibboleth.idp.attribute.filter.impl
Implementations of core attribute filter functionality.
net.shibboleth.idp.attribute.filter.matcher.impl
Implementation of the various policy matchers.
net.shibboleth.idp.attribute.filter.matcher.logic.impl
Implementation of the logical attribute matchers.
net.shibboleth.idp.attribute.filter.matcher.saml.impl
This is where the attribute matchers that understand SAML live.
net.shibboleth.idp.attribute.filter.testing
Testing utility classes.
net.shibboleth.idp.attribute.resolver
A system which is capable of retrieving a collection of `IdPAttribute`s from a variety of locations, transform them, and associate a set of protocol-specific encoders to them.
net.shibboleth.idp.attribute.resolver.ad.impl
Implementations of various `AttributeDefinition`s.
net.shibboleth.idp.attribute.resolver.dc
Interfaces supporting data connectors.
net.shibboleth.idp.attribute.resolver.dc.http.impl
A `DataConnector` implementation that reads data from an HTTP web service.
net.shibboleth.idp.attribute.resolver.dc.impl.testing
Testing utility classes.
net.shibboleth.idp.attribute.resolver.dc.ldap
Package for LDAP data connector configuration.
net.shibboleth.idp.attribute.resolver.dc.rdbms
Package for RDBMS data connector configuration.
net.shibboleth.idp.attribute.resolver.dc.saml
Package for SAML data connector configuration.
net.shibboleth.idp.attribute.resolver.dc.saml.impl
A `DataConnector` implementation that queries data from a SAML attribute authority.
net.shibboleth.idp.attribute.resolver.dc.saml.plugin.impl
Plug-in component interface implementations used when querying a SAML attribute authority.
net.shibboleth.idp.attribute.resolver.dc.scripted.impl
Classes which make up the scripted data connector.
net.shibboleth.idp.attribute.resolver.dc.storage.impl
Implementation of StorageService-backed data connector.
net.shibboleth.idp.attribute.resolver.impl
Implementations of core resolver functionality.
net.shibboleth.idp.saml.attribute.resolver.impl
Implementations of SAML related `AttributeDefinition` and `DataConnector`.
net.shibboleth.idp.saml.attribute.transcoding
Base classes for SAML `AttributeTranscoder` classes.
net.shibboleth.idp.saml.attribute.transcoding.impl
Implementations of SAML transcoders.
net.shibboleth.idp.saml.saml2.nameid.transcoding
API classes for SAML 2.0 NameID decoding classes.
net.shibboleth.idp.saml.saml2.nameid.transcoding.impl
SAML 2.0 NameID transcoder implementations.

## Uses of IdPAttributeValue in net.shibboleth.idp.attribute

Classes in net.shibboleth.idp.attribute that implement IdPAttributeValue
Modifier and Type
Class
Description
`final class`
`ByteAttributeValue`
A `byte[]` value for an `IdPAttribute`.
`class`
`DateTimeAttributeValue`
Base class for `IdPAttribute` values that are date/time values.
`final class`
`EmptyAttributeValue`
An `IdPAttributeValue` that is empty.
`final class`
`ScopedStringAttributeValue`
An attribute value with an associated scope.
`class`
`StringAttributeValue`
Base class for `IdPAttribute` values that are strings.
`final class`
`XMLObjectAttributeValue`
A `XMLObjectAttributeValue` value for an `IdPAttribute`.
Fields in net.shibboleth.idp.attribute with type parameters of type IdPAttributeValue
Modifier and Type
Field
Description
`private List<IdPAttributeValue>`
IdPAttribute.`values`
Values for this attribute.
Methods in net.shibboleth.idp.attribute that return IdPAttributeValue
Modifier and Type
Method
Description
`static IdPAttributeValue`
ByteAttributeValue.`valueOf(byte[] value)`
Returns an `EmptyAttributeValue` or `ByteAttributeValue` as appropriate.
`static IdPAttributeValue`
ScopedStringAttributeValue.`valueOf(String value, String scope)`
Returns an `EmptyAttributeValue` or `ScopedStringAttributeValue` as appropriate.
`static IdPAttributeValue`
StringAttributeValue.`valueOf(String value)`
Returns an `EmptyAttributeValue` or `StringAttributeValue` as appropriate.
Methods in net.shibboleth.idp.attribute that return types with arguments of type IdPAttributeValue
Modifier and Type
Method
Description
`List<IdPAttributeValue>`
IdPAttribute.`getValues()`
Get the unmodifiable ordered collection of values of the attribute.
Methods in net.shibboleth.idp.attribute with parameters of type IdPAttributeValue
Modifier and Type
Method
Description
`default int`
IdPAttributeValue.`compareTo(IdPAttributeValue value)`
Method parameters in net.shibboleth.idp.attribute with type arguments of type IdPAttributeValue
Modifier and Type
Method
Description
`void`
IdPAttribute.`setValues(List<IdPAttributeValue> newValues)`
Replaces the existing values for this attribute with the given values.

## Uses of IdPAttributeValue in net.shibboleth.idp.attribute.filter

Methods in net.shibboleth.idp.attribute.filter that return types with arguments of type IdPAttributeValue
Modifier and Type
Method
Description
`Set<IdPAttributeValue>`
Matcher.`getMatchingValues(IdPAttribute attribute, AttributeFilterContext filterContext)`
Return those `IdPAttributeValue`s which match this rule, or null if the matcher failed.
`Set<IdPAttributeValue>`
MatcherFromPolicy.`getMatchingValues(IdPAttribute attribute, AttributeFilterContext filterContext)`
Return those `IdPAttributeValue`s which match this rule, or null if the matcher failed.

## Uses of IdPAttributeValue in net.shibboleth.idp.attribute.filter.context

Fields in net.shibboleth.idp.attribute.filter.context with type parameters of type IdPAttributeValue
Modifier and Type
Field
Description
`private final Map<String,Set<IdPAttributeValue>>`
AttributeFilterWorkContext.`deniedValues`
Values, for a given attribute, that are not permitted to be released.
`private final Map<String,Set<IdPAttributeValue>>`
AttributeFilterWorkContext.`permittedValues`
Values, for a given attribute, that are permitted to be released.
Methods in net.shibboleth.idp.attribute.filter.context that return types with arguments of type IdPAttributeValue
Modifier and Type
Method
Description
`Map<String,Set<IdPAttributeValue>>`
AttributeFilterWorkContext.`getDeniedAttributeValues()`
Gets the unmodifiable collection of attribute values, indexed by ID, that are not permitted to be released.
`Map<String,Set<IdPAttributeValue>>`
AttributeFilterWorkContext.`getPermittedIdPAttributeValues()`
Gets the collection of attribute values, indexed by ID, that are permitted to be released.
Method parameters in net.shibboleth.idp.attribute.filter.context with type arguments of type IdPAttributeValue
Modifier and Type
Method
Description
`void`
AttributeFilterWorkContext.`addDeniedIdPAttributeValues(String attributeId, Collection<IdPAttributeValue> attributeValues)`
Adds a collection of attribute values that are not permitted to be released.
`void`
AttributeFilterWorkContext.`addPermittedIdPAttributeValues(String attributeId, Collection<IdPAttributeValue> attributeValues)`
Adds a collection of attribute values that are permitted to be released.

## Uses of IdPAttributeValue in net.shibboleth.idp.attribute.filter.impl

Methods in net.shibboleth.idp.attribute.filter.impl that return types with arguments of type IdPAttributeValue
Modifier and Type
Method
Description
`protected Collection<IdPAttributeValue>`
AttributeFilterImpl.`getFilteredValues(String attributeId, AttributeFilterContext filterContext)`
Gets the permitted values for the given attribute from the `AttributeFilterWorkContext.getPermittedIdPAttributeValues()` and removes all denied values given in the `AttributeFilterWorkContext.getDeniedAttributeValues()`.

## Uses of IdPAttributeValue in net.shibboleth.idp.attribute.filter.matcher.impl

Methods in net.shibboleth.idp.attribute.filter.matcher.impl that return types with arguments of type IdPAttributeValue
Modifier and Type
Method
Description
`Set<IdPAttributeValue>`
ScriptedMatcher.MatcherScriptEvaluator.`execute(IdPAttribute attribute, AttributeFilterContext filterContext)`
Execution hook.
`Set<IdPAttributeValue>`
AbstractMatcher.`getMatchingValues(IdPAttribute attribute, AttributeFilterContext filterContext)`
Return those `IdPAttributeValue`s which match this rule, or null if the matcher failed.
`Set<IdPAttributeValue>`
ScriptedMatcher.`getMatchingValues(IdPAttribute attribute, AttributeFilterContext filterContext)`
Perform the AttributeValueMatching.
Methods in net.shibboleth.idp.attribute.filter.matcher.impl with parameters of type IdPAttributeValue
Modifier and Type
Method
Description
`protected abstract boolean`
AbstractMatcher.`compareAttributeValue(IdPAttributeValue value)`
Given a value do we match?
`boolean`
AttributeScopeRegexpMatcher.`compareAttributeValue(IdPAttributeValue value)`
Given a value do we match?
`boolean`
AttributeScopeStringMatcher.`compareAttributeValue(IdPAttributeValue value)`
Given a value do we match?
`boolean`
AttributeValueRegexpMatcher.`compareAttributeValue(IdPAttributeValue value)`
Given a value do we match?
`boolean`
AttributeValueStringMatcher.`compareAttributeValue(IdPAttributeValue value)`
Given a value do we match?

## Uses of IdPAttributeValue in net.shibboleth.idp.attribute.filter.matcher.logic.impl

Methods in net.shibboleth.idp.attribute.filter.matcher.logic.impl that return types with arguments of type IdPAttributeValue
Modifier and Type
Method
Description
`Set<IdPAttributeValue>`
AndMatcher.`getMatchingValues(IdPAttribute attribute, AttributeFilterContext filterContext)`
A given attribute value is considered to have matched if, and only if, it is returned by every composed.
`Set<IdPAttributeValue>`
NotMatcher.`getMatchingValues(IdPAttribute attribute, AttributeFilterContext filterContext)`
A given attribute value is considered to have matched if it is not returned by the composed `Matcher`.
`Set<IdPAttributeValue>`
OrMatcher.`getMatchingValues(IdPAttribute attribute, AttributeFilterContext filterContext)`
Return those `IdPAttributeValue`s which match this rule, or null if the matcher failed.

## Uses of IdPAttributeValue in net.shibboleth.idp.attribute.filter.matcher.saml.impl

Methods in net.shibboleth.idp.attribute.filter.matcher.saml.impl that return types with arguments of type IdPAttributeValue
Modifier and Type
Method
Description
`private Set<IdPAttributeValue>`
AttributeInMetadataMatcher.`filterValues(String attributeToLog, IdPAttribute attribute, List<XMLObject> requestedValues)`
Given an attribute and the requested values do the filtering.
`private Set<IdPAttributeValue>`
AttributeInMetadataMatcher.`filterValues(IdPAttribute attribute, List<IdPAttributeValue> requestedValues)`
Given an attribute and the requested values do the filtering.
`Set<IdPAttributeValue>`
AbstractMatchesShibMDScopeMatcher.`getMatchingValues(IdPAttribute attribute, AttributeFilterContext filterContext)`
Return those `IdPAttributeValue`s which match this rule, or null if the matcher failed.
`Set<IdPAttributeValue>`
AttributeInMetadataMatcher.`getMatchingValues(IdPAttribute attribute, AttributeFilterContext filterContext)`
Return those `IdPAttributeValue`s which match this rule, or null if the matcher failed.
Methods in net.shibboleth.idp.attribute.filter.matcher.saml.impl with parameters of type IdPAttributeValue
Modifier and Type
Method
Description
`protected abstract String`
AbstractMatchesShibMDScopeMatcher.`getCompareString(IdPAttributeValue value)`
Return the string we want to compare with for the provided value.
`protected String`
AttributeScopeMatchesShibMDScope.`getCompareString(IdPAttributeValue value)`
Return the string we want to compare with for the provided value.
`protected String`
AttributeValueMatchesShibMDScope.`getCompareString(IdPAttributeValue value)`
Return the string we want to compare with for the provided value.
Method parameters in net.shibboleth.idp.attribute.filter.matcher.saml.impl with type arguments of type IdPAttributeValue
Modifier and Type
Method
Description
`private Set<IdPAttributeValue>`
AttributeInMetadataMatcher.`filterValues(IdPAttribute attribute, List<IdPAttributeValue> requestedValues)`
Given an attribute and the requested values do the filtering.

## Uses of IdPAttributeValue in net.shibboleth.idp.attribute.filter.testing

Methods in net.shibboleth.idp.attribute.filter.testing that return types with arguments of type IdPAttributeValue
Modifier and Type
Method
Description
`Set<IdPAttributeValue>`
MockMatcher.`getMatchingValues(IdPAttribute attribute, AttributeFilterContext filterContext)`
Return those `IdPAttributeValue`s which match this rule, or null if the matcher failed.

## Uses of IdPAttributeValue in net.shibboleth.idp.attribute.resolver

Methods in net.shibboleth.idp.attribute.resolver that return types with arguments of type IdPAttributeValue
Modifier and Type
Method
Description
`static Map<String,List<IdPAttributeValue>>`
PluginDependencySupport.`getAllAttributeValues(AttributeResolverWorkContext workContext, Collection<ResolverAttributeDefinitionDependency> attributeDependencies, Collection<ResolverDataConnectorDependency> dataConnectorDependencies)`
Gets the values from all dependencies.
`static List<IdPAttributeValue>`
PluginDependencySupport.`getMergedAttributeValues(AttributeResolverWorkContext workContext, Collection<ResolverAttributeDefinitionDependency> attributeDependencies, Collection<ResolverDataConnectorDependency> dataConnectorDependencies, String attributeDefinitionId)`
Gets the values, as a single list, from all dependencies.
Method parameters in net.shibboleth.idp.attribute.resolver with type arguments of type IdPAttributeValue
Modifier and Type
Method
Description
`private static void`
PluginDependencySupport.`addAttribute(IdPAttribute source, Map<String,List<IdPAttributeValue>> target)`
Adds the values of the given attribute to the target collection of attribute values.
`private static void`
PluginDependencySupport.`mergeAttributeValues(IdPAttribute source, List<IdPAttributeValue> target)`
Adds the values of the given attribute to the set of attribute values.

## Uses of IdPAttributeValue in net.shibboleth.idp.attribute.resolver.ad.impl

Fields in net.shibboleth.idp.attribute.resolver.ad.impl with type parameters of type IdPAttributeValue
Modifier and Type
Field
Description
`private Function<ProfileRequestContext,List<IdPAttributeValue>>`
ContextDerivedAttributeDefinition.`attributeValuesFunction`
Function used to generate the values associated with the `ProfileRequestContext` The function returns null or an empty list if the context isn't relevant.
Methods in net.shibboleth.idp.attribute.resolver.ad.impl that return IdPAttributeValue
Modifier and Type
Method
Description
`private IdPAttributeValue`
PrescopedAttributeDefinition.`buildScopedStringAttributeValue(StringAttributeValue value)`
Builds a `ScopedStringAttributeValue` from a `StringAttributeValue` whose value contains a delimited value.
Methods in net.shibboleth.idp.attribute.resolver.ad.impl with parameters of type IdPAttributeValue
Modifier and Type
Method
Description
`protected DateTimeAttributeValue`
DateTimeAttributeDefinition.`convert(IdPAttributeValue input)`
Convert an input value into a `DateTimeAttributeValue` if possible.
Method parameters in net.shibboleth.idp.attribute.resolver.ad.impl with type arguments of type IdPAttributeValue
Modifier and Type
Method
Description
`private void`
ScriptedIdPAttributeImpl.`addAsIdPAttributeValue(List<IdPAttributeValue> values, Object value)`
Add the provided value to the provided list, converting `String` to `StringAttributeValue`.
`private int`
TemplateAttributeDefinition.`addAttributeValues(String attributeName, List<IdPAttributeValue> attributeValues, Map<String,Iterator<IdPAttributeValue>> sourceValues, int curValueCount)`
Add values for a given attribute to the source Map.
`private int`
TemplateAttributeDefinition.`addAttributeValues(String attributeName, List<IdPAttributeValue> attributeValues, Map<String,Iterator<IdPAttributeValue>> sourceValues, int curValueCount)`
Add values for a given attribute to the source Map.
`void`
ContextDerivedAttributeDefinition.`setAttributeValuesFunction(Function<ProfileRequestContext,List<IdPAttributeValue>> function)`
Sets the attribute value function.
`private int`
TemplateAttributeDefinition.`setupSourceValues(AttributeResolverWorkContext workContext, Map<String,Iterator<IdPAttributeValue>> sourceValues)`
Set up a map which can be used to populate the template.

## Uses of IdPAttributeValue in net.shibboleth.idp.attribute.resolver.dc

Method parameters in net.shibboleth.idp.attribute.resolver.dc with type arguments of type IdPAttributeValue
Modifier and Type
Method
Description
`T`
ExecutableSearchBuilder.`build(AttributeResolutionContext resolutionContext, Map<String,List<IdPAttributeValue>> dependencyAttributes)`
Creates an executable search that can be executed against a data source in order to produce results.

## Uses of IdPAttributeValue in net.shibboleth.idp.attribute.resolver.dc.http.impl

Method parameters in net.shibboleth.idp.attribute.resolver.dc.http.impl with type arguments of type IdPAttributeValue
Modifier and Type
Method
Description
`HTTPSearch`
AbstractHTTPSearchBuilder.`build(AttributeResolutionContext resolutionContext, Map<String,List<IdPAttributeValue>> dependencyAttributes)`
Creates an executable search that can be executed against a data source in order to produce results.
`protected org.apache.hc.core5.http.ClassicHttpRequest`
AbstractHTTPSearchBuilder.`getHttpRequest(AttributeResolutionContext resolutionContext, Map<String,List<IdPAttributeValue>> dependencyAttributes)`
Default implementation just supports GET and builds a request around a URL.
`protected org.apache.hc.core5.http.ClassicHttpRequest`
TemplatedBodyBuilder.`getHttpRequest(AttributeResolutionContext resolutionContext, Map<String,List<IdPAttributeValue>> dependencyAttributes)`
Default implementation just supports GET and builds a request around a URL.
`protected String`
AbstractHTTPSearchBuilder.`getResultCacheKey(org.apache.hc.core5.http.ClassicHttpRequest request, AttributeResolutionContext resolutionContext, Map<String,List<IdPAttributeValue>> dependencyAttributes)`
Default implementation just allows caching of GET requests and returns the URI itself.
`protected String`
TemplatedBodyBuilder.`getResultCacheKey(org.apache.hc.core5.http.ClassicHttpRequest request, AttributeResolutionContext resolutionContext, Map<String,List<IdPAttributeValue>> dependencyAttributes)`
Default implementation just allows caching of GET requests and returns the URI itself.
`protected String`
AbstractHTTPSearchBuilder.`getURL(AttributeResolutionContext resolutionContext, Map<String,List<IdPAttributeValue>> dependencyAttributes)`
Method to return the URL to access via GET.
`protected String`
TemplatedURLBuilder.`getURL(AttributeResolutionContext resolutionContext, Map<String,List<IdPAttributeValue>> dependencyAttributes)`
Method to return the URL to access via GET.

## Uses of IdPAttributeValue in net.shibboleth.idp.attribute.resolver.dc.impl.testing

Methods in net.shibboleth.idp.attribute.resolver.dc.impl.testing that return IdPAttributeValue
Modifier and Type
Method
Description
`private IdPAttributeValue`
SAMLAttributeDataConnector.`encodeString(XSString inputString)`
Encode a string into an attribute value.
`protected IdPAttributeValue`
SAMLAttributeDataConnector.`encodeValue(XMLObject object)`
Method to convert a singled `XMLObject` into an `IdPAttributeValue` if possible.
Methods in net.shibboleth.idp.attribute.resolver.dc.impl.testing that return types with arguments of type IdPAttributeValue
Modifier and Type
Method
Description
`protected List<IdPAttributeValue>`
SAMLAttributeDataConnector.`encodeValues(List<XMLObject> attributeValues)`
Encode a list of SAML objects as set of `IdPAttributeValue`.

## Uses of IdPAttributeValue in net.shibboleth.idp.attribute.resolver.dc.ldap

Method parameters in net.shibboleth.idp.attribute.resolver.dc.ldap with type arguments of type IdPAttributeValue
Modifier and Type
Method
Description
`ExecutableSearchFilter`
ParameterizedExecutableSearchFilterBuilder.`build(AttributeResolutionContext resolutionContext, Map<String,List<IdPAttributeValue>> dependencyAttributes)`
Creates an executable search that can be executed against a data source in order to produce results.
`ExecutableSearchFilter`
TemplatedExecutableSearchFilterBuilder.`build(AttributeResolutionContext resolutionContext, Map<String,List<IdPAttributeValue>> dependencyAttributes)`
Creates an executable search that can be executed against a data source in order to produce results.

## Uses of IdPAttributeValue in net.shibboleth.idp.attribute.resolver.dc.rdbms

Method parameters in net.shibboleth.idp.attribute.resolver.dc.rdbms with type arguments of type IdPAttributeValue
Modifier and Type
Method
Description
`ExecutableStatement`
AbstractExecutableStatementBuilder.`build(AttributeResolutionContext resolutionContext, Map<String,List<IdPAttributeValue>> dependencyAttributes)`
Creates an executable search that can be executed against a data source in order to produce results.
`protected abstract String`
AbstractExecutableStatementBuilder.`getSQLQuery(AttributeResolutionContext resolutionContext, Map<String,List<IdPAttributeValue>> dependencyAttributes)`
Method to return the query SQL.
`protected String`
FormatExecutableStatementBuilder.`getSQLQuery(AttributeResolutionContext resolutionContext, Map<String,List<IdPAttributeValue>> dependencyAttributes)`
Method to return the query SQL.
`final String`
TemplatedExecutableStatementBuilder.`getSQLQuery(AttributeResolutionContext resolutionContext, Map<String,List<IdPAttributeValue>> dependencyAttributes)`
Apply the context to the template.

## Uses of IdPAttributeValue in net.shibboleth.idp.attribute.resolver.dc.saml

Fields in net.shibboleth.idp.attribute.resolver.dc.saml with type parameters of type IdPAttributeValue
Modifier and Type
Field
Description
`private Map<String,List<IdPAttributeValue>>`
ResponseData.`dependencyAttributes`
Dependency attributes.
Methods in net.shibboleth.idp.attribute.resolver.dc.saml that return types with arguments of type IdPAttributeValue
Modifier and Type
Method
Description
`Map<String,List<IdPAttributeValue>>`
ResponseData.`getDependencyAttributes()`
Get the resolution dependency attributes.
Constructor parameters in net.shibboleth.idp.attribute.resolver.dc.saml with type arguments of type IdPAttributeValue
Modifier
Constructor
Description
``
`ResponseData(Response message, InOutOperationContext soapContext, AttributeResolutionContext attributeContext, Map<String,List<IdPAttributeValue>> dependencies, RoleDescriptor roleDescriptor)`
Constructor.

## Uses of IdPAttributeValue in net.shibboleth.idp.attribute.resolver.dc.saml.impl

Fields in net.shibboleth.idp.attribute.resolver.dc.saml.impl with type parameters of type IdPAttributeValue
Modifier and Type
Field
Description
`private final Map<String,List<IdPAttributeValue>>`
ExecutableQueryBuilder.StandardExecutableQuery.`dependencyAttributes`
Dependency attributes.
Method parameters in net.shibboleth.idp.attribute.resolver.dc.saml.impl with type arguments of type IdPAttributeValue
Modifier and Type
Method
Description
`ExecutableQuery`
ExecutableQueryBuilder.`build(AttributeResolutionContext resolutionContext, Map<String,List<IdPAttributeValue>> dependencyAttributes)`
Creates an executable search that can be executed against a data source in order to produce results.
`private SAMLObject`
ExecutableQueryBuilder.`buildAttributeQueryMessage(AttributeResolutionContext resolutionContext, Map<String,List<IdPAttributeValue>> dependencyAttributes, AttributeAuthorityDescriptor roleDescriptor, String endpoint, String selfEntityID)`
Build the attribute query message to be sent to the attribute authority.
`private InOutOperationContext`
ExecutableQueryBuilder.`buildOperationContext(AttributeResolutionContext resolutionContext, Map<String,List<IdPAttributeValue>> dependencyAttributes, AttributeAuthorityDescriptor roleDescriptor, String endpoint)`
Build the SOAP client operation context.
`private List<Attribute>`
ExecutableQueryBuilder.`buildRequestAttributes(AttributeResolutionContext resolutionContext, Map<String,List<IdPAttributeValue>> dependencyAttributes, AttributeAuthorityDescriptor roleDescriptor)`
Build the list of requested attributes for the SAML protocol message.
`private Subject`
ExecutableQueryBuilder.`buildSubject(AttributeResolutionContext resolutionContext, Map<String,List<IdPAttributeValue>> dependencyAttributes, AttributeAuthorityDescriptor roleDescriptor)`
Build SAML protocol message Subject element.
`String`
AttributeAuthorityEntityIDResolver.`resolve(AttributeResolutionContext resolutionContext, Map<String,List<IdPAttributeValue>> dependencyAttributes)`
Resolve the entity ID of the attribute authority to use in query.
`String`
SelfEntityIDResolver.`resolve(AttributeResolutionContext resolutionContext, Map<String,List<IdPAttributeValue>> dependencyAttributes, AttributeAuthorityDescriptor roleDescriptor)`
Resolve the self entity ID to use in query.
`Subject`
SubjectResolver.`resolve(AttributeResolutionContext resolutionContext, Map<String,List<IdPAttributeValue>> dependencyAttributes, AttributeAuthorityDescriptor roleDescriptor)`
Resolve the `Subject` to use in query.
`private String`
ExecutableQueryBuilder.`resolveAttributeAuthorityEntityID(AttributeResolutionContext resolutionContext, Map<String,List<IdPAttributeValue>> dependencyAttributes)`
Resolve the attribute authority entityID.
`private String`
ExecutableQueryBuilder.`resolveSelfEntityID(AttributeResolutionContext resolutionContext, Map<String,List<IdPAttributeValue>> dependencyAttributes, AttributeAuthorityDescriptor roleDescriptor)`
Resolve the entity ID of the protocol message issuer (this entity).
Constructor parameters in net.shibboleth.idp.attribute.resolver.dc.saml.impl with type arguments of type IdPAttributeValue
Modifier
Constructor
Description
`private`
`StandardExecutableQuery(String entityID, AttributeAuthorityDescriptor roleDescriptor, String endpoint, InOutOperationContext clientContext, AttributeResolutionContext arc, Map<String,List<IdPAttributeValue>> dependencies)`
Constructor.

## Uses of IdPAttributeValue in net.shibboleth.idp.attribute.resolver.dc.saml.plugin.impl

Method parameters in net.shibboleth.idp.attribute.resolver.dc.saml.plugin.impl with type arguments of type IdPAttributeValue
Modifier and Type
Method
Description
`String`
ChainingAuthorityEntityIDResolver.`resolve(AttributeResolutionContext resolutionContext, Map<String,List<IdPAttributeValue>> dependencyAttributes)`
Resolve the entity ID of the attribute authority to use in query.
`String`
ChainingSelfEntityIDResolver.`resolve(AttributeResolutionContext resolutionContext, Map<String,List<IdPAttributeValue>> dependencyAttributes, AttributeAuthorityDescriptor roleDescriptor)`
Resolve the self entity ID to use in query.
`Subject`
ChainingSubjectResolver.`resolve(AttributeResolutionContext resolutionContext, Map<String,List<IdPAttributeValue>> dependencyAttributes, AttributeAuthorityDescriptor roleDescriptor)`
Resolve the `Subject` to use in query.
`String`
ContextAuthorityEntityIDResolver.`resolve(AttributeResolutionContext resolutionContext, Map<String,List<IdPAttributeValue>> dependencyAttributes)`
Resolve the entity ID of the attribute authority to use in query.
`String`
CriteriaSelfEntityIDResolver.`resolve(AttributeResolutionContext resolutionContext, Map<String,List<IdPAttributeValue>> dependencyAttributes, AttributeAuthorityDescriptor roleDescriptor)`
Resolve the self entity ID to use in query.
`Subject`
DependencyAttributeSubjectResolver.`resolve(AttributeResolutionContext resolutionContext, Map<String,List<IdPAttributeValue>> dependencyAttributes, AttributeAuthorityDescriptor roleDescriptor)`
Resolve the `Subject` to use in query.

## Uses of IdPAttributeValue in net.shibboleth.idp.attribute.resolver.dc.scripted.impl

Method parameters in net.shibboleth.idp.attribute.resolver.dc.scripted.impl with type arguments of type IdPAttributeValue
Modifier and Type
Method
Description
`ScriptedSearch`
ScriptedSearchBuilder.`build(AttributeResolutionContext resolutionContext, Map<String,List<IdPAttributeValue>> dependencyAttributes)`
Creates an executable search that can be executed against a data source in order to produce results.
`private String`
ScriptedSearchBuilder.`getResultCacheKey(AttributeResolutionContext resolutionContext, Map<String,List<IdPAttributeValue>> dependencyAttributes)`
Allow a user-provided cache key for this resolution.

## Uses of IdPAttributeValue in net.shibboleth.idp.attribute.resolver.dc.storage.impl

Method parameters in net.shibboleth.idp.attribute.resolver.dc.storage.impl with type arguments of type IdPAttributeValue
Modifier and Type
Method
Description
`StorageServiceSearch`
TemplatedSearchBuilder.`build(AttributeResolutionContext resolutionContext, Map<String,List<IdPAttributeValue>> dependencyAttributes)`
Creates an executable search that can be executed against a data source in order to produce results.
`private TemplatedSearchBuilder.ContextAndKey`
TemplatedSearchBuilder.`getContextAndKey(AttributeResolutionContext resolutionContext, Map<String,List<IdPAttributeValue>> dependencyAttributes)`
Helper method to extract the parameters needed for the `StorageServiceSearch`.

## Uses of IdPAttributeValue in net.shibboleth.idp.attribute.resolver.impl

Methods in net.shibboleth.idp.attribute.resolver.impl that return types with arguments of type IdPAttributeValue
Modifier and Type
Method
Description
`private List<IdPAttributeValue>`
AttributeResolverImpl.`filterAttributeValues(String attributeId, List<IdPAttributeValue> input)`
Helper method for exporting attributes.
Method parameters in net.shibboleth.idp.attribute.resolver.impl with type arguments of type IdPAttributeValue
Modifier and Type
Method
Description
`private List<IdPAttributeValue>`
AttributeResolverImpl.`filterAttributeValues(String attributeId, List<IdPAttributeValue> input)`
Helper method for exporting attributes.

## Uses of IdPAttributeValue in net.shibboleth.idp.saml.attribute.resolver.impl

Methods in net.shibboleth.idp.saml.attribute.resolver.impl with parameters of type IdPAttributeValue
Modifier and Type
Method
Description
`private XMLObjectAttributeValue`
SAML1NameIdentifierAttributeDefinition.`encodeOneValue(IdPAttributeValue theValue, AttributeResolutionContext resolutionContext)`
Deprecated, for removal: This API element is subject to removal in a future version.
Worker function for doAttributeDefintionResolve.
`private XMLObjectAttributeValue`
SAML2NameIDAttributeDefinition.`encodeOneValue(IdPAttributeValue theValue, AttributeResolutionContext resolutionContext)`
Deprecated, for removal: This API element is subject to removal in a future version.
Worker function for doAttributeDefintionResolve.

## Uses of IdPAttributeValue in net.shibboleth.idp.saml.attribute.transcoding

Classes in net.shibboleth.idp.saml.attribute.transcoding with type parameters of type IdPAttributeValue
Modifier and Type
Class
Description
`class`
`AbstractSAML1AttributeTranscoder<EncodedType extends IdPAttributeValue>`
Base class for transcoders that operate on a SAML 1 `Attribute` or `AttributeDesignator`.
`class`
`AbstractSAML2AttributeTranscoder<EncodedType extends IdPAttributeValue>`
Base class for transcoders that operate on a SAML 2 `Attribute` or `RequestedAttribute`.
`class`
`AbstractSAMLAttributeTranscoder<AttributeType extends SAMLObject,EncodedType extends IdPAttributeValue>`
Base class for transcoders that support SAML attributes.
`interface`
`SAML1AttributeTranscoder<EncodedType extends IdPAttributeValue>`
Marker interface for transcoders that operate on a SAML 1 `Attribute` or `AttributeDesignator`.
`interface`
`SAML2AttributeTranscoder<EncodedType extends IdPAttributeValue>`
Marker interface for transcoders that operate on a SAML 2 `Attribute` or `RequestedAttribute`.
Methods in net.shibboleth.idp.saml.attribute.transcoding that return IdPAttributeValue
Modifier and Type
Method
Description
`protected abstract IdPAttributeValue`
AbstractSAMLAttributeTranscoder.`decodeValue(ProfileRequestContext profileRequestContext, AttributeType attribute, TranscodingRule rule, XMLObject value)`
Function to decode a single `XMLObject` into an `IdPAttributeValue`.
Methods in net.shibboleth.idp.saml.attribute.transcoding with parameters of type IdPAttributeValue
Modifier and Type
Method
Description
`protected abstract boolean`
AbstractSAMLAttributeTranscoder.`canEncodeValue(IdPAttribute idpAttribute, IdPAttributeValue value)`
Checks if the given value can be handled by the transcoder.
Method parameters in net.shibboleth.idp.saml.attribute.transcoding with type arguments of type IdPAttributeValue
Modifier and Type
Method
Description
`protected IdPAttribute`
AbstractSAML1AttributeTranscoder.`buildIdPAttribute(ProfileRequestContext profileRequestContext, AttributeDesignator attribute, TranscodingRule rule, List<IdPAttributeValue> attributeValues)`
Builds an `IdPAttribute` from the given values.
`protected IdPAttribute`
AbstractSAML2AttributeTranscoder.`buildIdPAttribute(ProfileRequestContext profileRequestContext, Attribute attribute, TranscodingRule rule, List<IdPAttributeValue> attributeValues)`
Builds an `IdPAttribute` from the given values.
`protected abstract IdPAttribute`
AbstractSAMLAttributeTranscoder.`buildIdPAttribute(ProfileRequestContext profileRequestContext, AttributeType attribute, TranscodingRule rule, List<IdPAttributeValue> attributeValues)`
Builds an `IdPAttribute` from the given values.

## Uses of IdPAttributeValue in net.shibboleth.idp.saml.attribute.transcoding.impl

Methods in net.shibboleth.idp.saml.attribute.transcoding.impl that return IdPAttributeValue
Modifier and Type
Method
Description
`protected IdPAttributeValue`
SAML1ByteAttributeTranscoder.`decodeValue(ProfileRequestContext profileRequestContext, AttributeDesignator attribute, TranscodingRule rule, XMLObject value)`
Function to decode a single `XMLObject` into an `IdPAttributeValue`.
`protected IdPAttributeValue`
SAML1ScopedStringAttributeTranscoder.`decodeValue(ProfileRequestContext profileRequestContext, AttributeDesignator attribute, TranscodingRule rule, XMLObject value)`
Function to decode a single `XMLObject` into an `IdPAttributeValue`.
`protected IdPAttributeValue`
SAML1StringAttributeTranscoder.`decodeValue(ProfileRequestContext profileRequestContext, AttributeDesignator attribute, TranscodingRule rule, XMLObject value)`
Function to decode a single `XMLObject` into an `IdPAttributeValue`.
`protected IdPAttributeValue`
SAML1XMLObjectAttributeTranscoder.`decodeValue(ProfileRequestContext profileRequestContext, AttributeDesignator attribute, TranscodingRule rule, XMLObject value)`
Function to decode a single `XMLObject` into an `IdPAttributeValue`.
`protected IdPAttributeValue`
SAML2ByteAttributeTranscoder.`decodeValue(ProfileRequestContext profileRequestContext, Attribute attribute, TranscodingRule rule, XMLObject value)`
Function to decode a single `XMLObject` into an `IdPAttributeValue`.
`protected IdPAttributeValue`
SAML2DateTimeAttributeTranscoder.`decodeValue(ProfileRequestContext profileRequestContext, Attribute attribute, TranscodingRule rule, XMLObject value)`
Function to decode a single `XMLObject` into an `IdPAttributeValue`.
`protected IdPAttributeValue`
SAML2ScopedStringAttributeTranscoder.`decodeValue(ProfileRequestContext profileRequestContext, Attribute attribute, TranscodingRule rule, XMLObject value)`
Function to decode a single `XMLObject` into an `IdPAttributeValue`.
`protected IdPAttributeValue`
SAML2StringAttributeTranscoder.`decodeValue(ProfileRequestContext profileRequestContext, Attribute attribute, TranscodingRule rule, XMLObject value)`
Function to decode a single `XMLObject` into an `IdPAttributeValue`.
`protected IdPAttributeValue`
SAML2XMLObjectAttributeTranscoder.`decodeValue(ProfileRequestContext profileRequestContext, Attribute attribute, TranscodingRule rule, XMLObject value)`
Function to decode a single `XMLObject` into an `IdPAttributeValue`.
Methods in net.shibboleth.idp.saml.attribute.transcoding.impl with parameters of type IdPAttributeValue
Modifier and Type
Method
Description
`protected boolean`
SAML1ByteAttributeTranscoder.`canEncodeValue(IdPAttribute attribute, IdPAttributeValue value)`
Checks if the given value can be handled by the transcoder.
`protected boolean`
SAML1ScopedStringAttributeTranscoder.`canEncodeValue(IdPAttribute attribute, IdPAttributeValue value)`
Checks if the given value can be handled by the transcoder.
`protected boolean`
SAML1StringAttributeTranscoder.`canEncodeValue(IdPAttribute attribute, IdPAttributeValue value)`
Checks if the given value can be handled by the transcoder.
`protected boolean`
SAML1XMLObjectAttributeTranscoder.`canEncodeValue(IdPAttribute attribute, IdPAttributeValue value)`
Checks if the given value can be handled by the transcoder.
`protected boolean`
SAML2ByteAttributeTranscoder.`canEncodeValue(IdPAttribute attribute, IdPAttributeValue value)`
Checks if the given value can be handled by the transcoder.
`protected boolean`
SAML2DateTimeAttributeTranscoder.`canEncodeValue(IdPAttribute attribute, IdPAttributeValue value)`
Checks if the given value can be handled by the transcoder.
`protected boolean`
SAML2ScopedStringAttributeTranscoder.`canEncodeValue(IdPAttribute attribute, IdPAttributeValue value)`
Checks if the given value can be handled by the transcoder.
`protected boolean`
SAML2StringAttributeTranscoder.`canEncodeValue(IdPAttribute attribute, IdPAttributeValue value)`
Checks if the given value can be handled by the transcoder.
`protected boolean`
SAML2XMLObjectAttributeTranscoder.`canEncodeValue(IdPAttribute attribute, IdPAttributeValue value)`
Checks if the given value can be handled by the transcoder.

## Uses of IdPAttributeValue in net.shibboleth.idp.saml.saml2.nameid.transcoding

Classes in net.shibboleth.idp.saml.saml2.nameid.transcoding with type parameters of type IdPAttributeValue
Modifier and Type
Class
Description
`class`
`AbstractSAML2NameIDTranscoder<EncodedType extends IdPAttributeValue>`
Base class for transcoders that operate on a SAML 2 `NameID`.
`interface`
`SAML2NameIDTranscoder<EncodedType extends IdPAttributeValue>`
Marker interface for transcoders that operate on a SAML 2 `NameID`.
Method parameters in net.shibboleth.idp.saml.saml2.nameid.transcoding with type arguments of type IdPAttributeValue
Modifier and Type
Method
Description
`protected IdPAttribute`
AbstractSAML2NameIDTranscoder.`buildIdPAttribute(ProfileRequestContext profileRequestContext, NameID nameID, TranscodingRule rule, List<IdPAttributeValue> attributeValues)`
Builds an `IdPAttribute` from the given values.

## Uses of IdPAttributeValue in net.shibboleth.idp.saml.saml2.nameid.transcoding.impl

Methods in net.shibboleth.idp.saml.saml2.nameid.transcoding.impl that return IdPAttributeValue
Modifier and Type
Method
Description
`protected IdPAttributeValue`
SAML2ScopedStringNameIDTranscoder.`decodeValue(ProfileRequestContext profileRequestContext, NameID nameID, TranscodingRule rule, XMLObject value)`
Function to decode a single `XMLObject` into an `IdPAttributeValue`.
`protected IdPAttributeValue`
SAML2StringNameIDTranscoder.`decodeValue(ProfileRequestContext profileRequestContext, NameID nameID, TranscodingRule rule, XMLObject value)`
Function to decode a single `XMLObject` into an `IdPAttributeValue`.
Methods in net.shibboleth.idp.saml.saml2.nameid.transcoding.impl with parameters of type IdPAttributeValue
Modifier and Type
Method
Description
`protected boolean`
SAML2ScopedStringNameIDTranscoder.`canEncodeValue(IdPAttribute attribute, IdPAttributeValue value)`
Checks if the given value can be handled by the transcoder.
`protected boolean`
SAML2StringNameIDTranscoder.`canEncodeValue(IdPAttribute attribute, IdPAttributeValue value)`
Checks if the given value can be handled by the transcoder.